graphe={'Marion': ['Leonor', 'Rodrigo', 'Martim', 'Sami'], 'Frédéric': ['Leonor', 'Louis', 'Jérémy'], 'Leonor': ['Marion', 'Frédéric', 'Rodrigo', 'Quentin'], 'Louis': ['Frédéric', 'Martim'], 'Jérémy': ['Frédéric', 'Quentin', 'Sami'], 'Quentin': ['Leonor', 'Jérémy', 'Sami'], 'Rodrigo': ['Marion', 'Leonor', 'Sami'], 'Martim': ['Marion', 'Louis', 'Sami'], 'Sami': ['Marion', 'Jérémy', 'Quentin', 'Rodrigo', 'Martim']}

maze={'A1': ['A2'],
       'C1': ['C2'],
       'E1': ['F1'],
       'F1': ['E1','G1','F2'],
       'G1': ['F1'],
       'I1': [],
       'A2': ['B2'],
       'B2': ['A2','C2','B3'],
        'C2': ['B2','D2','C3','C1'],
        'D2': ['C2','D3'],
        'F2': ['F1'],
        'H2': ['H3'],
        'B3': ['B2','C3','B4'],
        'C3': ['B3','D3','C2'],
        'D3': ['D2','C3','E3','D4'],
        'E3': ['D3','E4'],
        'G3': ['G4','H3'],
        'H3': ['H2','G3','I3'],
        'I3': ['H3','I4'],
        'A4': ['B4','A5'],
        'B4': ['A4','B3','B5'],
        'D4': ['D3','E4'],
        'E4': ['E3','F4','D4'],
        'F4': ['E4','G4','F5'],
        'G4': ['F4','G3','G5'],
        'I4': ['I3','I5'],
        'A5': ['A4','B5'],
        'B5': ['A5','C5','B4','B6'],
        'C5': ['B5','C6'],
        'F5': ['F4','G5'],
        'G5': ['F5','H5','G4'],
        'H5': ['G5','I5','H6'],
      'I5': ['I4','H5'],
        'B6': ['B5','C6'],
        'C6': ['C5','C7','B6'],
        'E6': ['E7'],
        'H6': ['H5','H7'],
        'A7': [],
        'C7': ['C6','C8','D7'],
        'D7': ['C7','E7','D8'],
        'E7': ['E6','D7'],
        'G7': ['H7'],
        'H7': ['G7','H6','H8'],
        'C8': ['C7','D8'],
        'D8': ['D7','D9','C8'],
        'F8': ['F9'],
        'H8': ['H7','H9','I8'],
        'I8': ['H8','I9'],
        'A9': [],
        'D9': ['D8'],
        'F9': ['F8','G9'],
        'G9': ['F9','H9'],
        'H9': ['G9','H8','I9'],
        'I9': ['H9','I8']      
       }

parents=dict() # initialisation du dictionnaire arbre couvrant

def bfs(graphe, depart):
    parcours=[] # liste des sommets parcourus en largeur
    visites=[depart] # sommet de départ visité
    file = []     
    file.append(depart)

    while file:    
        sommet = file.pop(0) # sommet à traiter
        parcours.append(sommet) # sommet ajouté
        # on ajoute dans la file les voisins non visités pour les traiter
        for voisin in graphe[sommet]:
            if voisin not in visites:
                visites.append(voisin)
                file.append(voisin)
    return parcours 

print(bfs(maze,'A1'))

chemin=['I9'] # liste du chemin le plus court en partant du but

def path(dico,but):
    '''
    dico-> dictionnaire de l´arbre couvrant
    but -> la case de sortie
    retourne la liste "chemin"
    '''
    for key, value in dico.items():
        if but in value:
            pass

#print('\nLe chemin:',path(bfs(maze, 'A1'),'I9'))
